Index: protocols/bee_user.c
===================================================================
--- protocols/bee_user.c	(revision a4ac9c413b97decae5adf15b69f4bbfdce0ef5e4)
+++ protocols/bee_user.c	(revision 10425b2455a0d4b7bc7087572b236b0fc6ecef8d)
@@ -201,5 +201,5 @@
 
 	/* May be nice to give the UI something to compare against. */
-	old = g_memdup(bu, sizeof(bee_user_t));
+	old = g_memdup2(bu, sizeof(bee_user_t));
 
 	/* TODO(wilmer): OPT_AWAY, or just state == NULL ? */
@@ -239,5 +239,5 @@
 	}
 
-	old = g_memdup(bu, sizeof(bee_user_t));
+	old = g_memdup2(bu, sizeof(bee_user_t));
 
 	bu->status_msg = message && *message ? g_strdup(message) : NULL;
Index: protocols/jabber/io.c
===================================================================
--- protocols/jabber/io.c	(revision a4ac9c413b97decae5adf15b69f4bbfdce0ef5e4)
+++ protocols/jabber/io.c	(revision 10425b2455a0d4b7bc7087572b236b0fc6ecef8d)
@@ -63,5 +63,5 @@
 		/* If the queue is empty, allocate a new buffer. */
 		jd->tx_len = len;
-		jd->txq = g_memdup(buf, len);
+		jd->txq = g_memdup2(buf, len);
 
 		/* Try if we can write it immediately so we don't have to do
@@ -134,5 +134,5 @@
 		char *s;
 
-		s = g_memdup(jd->txq + st, jd->tx_len - st);
+		s = g_memdup2(jd->txq + st, jd->tx_len - st);
 		jd->tx_len -= st;
 		g_free(jd->txq);
Index: protocols/jabber/jabber.c
===================================================================
--- protocols/jabber/jabber.c	(revision a4ac9c413b97decae5adf15b69f4bbfdce0ef5e4)
+++ protocols/jabber/jabber.c	(revision 10425b2455a0d4b7bc7087572b236b0fc6ecef8d)
@@ -803,5 +803,5 @@
 
 	/* Another one for hipchat, which has completely different logins */
-	hipchat = g_memdup(ret, sizeof(struct prpl));
+	hipchat = g_memdup2(ret, sizeof(struct prpl));
 	hipchat->name = "hipchat";
 	register_protocol(hipchat);
Index: protocols/purple/ft-direct.c
===================================================================
--- protocols/purple/ft-direct.c	(revision a4ac9c413b97decae5adf15b69f4bbfdce0ef5e4)
+++ protocols/purple/ft-direct.c	(revision 10425b2455a0d4b7bc7087572b236b0fc6ecef8d)
@@ -71,5 +71,5 @@
 	struct prpl_xfer_data *px = ft->data;
 
-	px->buf = g_memdup(buffer, len);
+	px->buf = g_memdup2(buffer, len);
 	px->buf_len = len;
 
Index: protocols/purple/purple.c
===================================================================
--- protocols/purple/purple.c	(revision a4ac9c413b97decae5adf15b69f4bbfdce0ef5e4)
+++ protocols/purple/purple.c	(revision 10425b2455a0d4b7bc7087572b236b0fc6ecef8d)
@@ -1937,5 +1937,5 @@
 		}
 
-		ret = g_memdup(&funcs, sizeof(funcs));
+		ret = g_memdup2(&funcs, sizeof(funcs));
 		ret->name = ret->data = prot->info->id;
 		if (strncmp(ret->name, "prpl-", 5) == 0) {
Index: protocols/twitter/twitter.c
===================================================================
--- protocols/twitter/twitter.c	(revision a4ac9c413b97decae5adf15b69f4bbfdce0ef5e4)
+++ protocols/twitter/twitter.c	(revision 10425b2455a0d4b7bc7087572b236b0fc6ecef8d)
@@ -1117,5 +1117,5 @@
 
 	/* And an identi.ca variant: */
-	ret = g_memdup(ret, sizeof(struct prpl));
+	ret = g_memdup2(ret, sizeof(struct prpl));
 	ret->name = "identica";
 	ret->options =  PRPL_OPT_NOOTR;
Index: protocols/twitter/twitter_lib.c
===================================================================
--- protocols/twitter/twitter_lib.c	(revision a4ac9c413b97decae5adf15b69f4bbfdce0ef5e4)
+++ protocols/twitter/twitter_lib.c	(revision 10425b2455a0d4b7bc7087572b236b0fc6ecef8d)
@@ -647,5 +647,5 @@
 		}
 	} else if (text_value && text_value->type == json_string) {
-		txs->text = g_memdup(text_value->u.string.ptr, text_value->u.string.length + 1);
+		txs->text = g_memdup2(text_value->u.string.ptr, text_value->u.string.length + 1);
 		strip_html(txs->text);
 		expand_entities(&txs->text, node, extended_node);
@@ -674,5 +674,5 @@
 	JSON_O_FOREACH(node, k, v) {
 		if (strcmp("text", k) == 0 && v->type == json_string) {
-			txs->text = g_memdup(v->u.string.ptr, v->u.string.length + 1);
+			txs->text = g_memdup2(v->u.string.ptr, v->u.string.length + 1);
 			strip_html(txs->text);
 		} else if (strcmp("created_at", k) == 0 && v->type == json_string) {